#include "Board.h"

Board::Board() :
    m_board
{
  "/--------------\\  score:00000    /--------------\\",
  "|.......#.....#\\-----------------/#.....#.......|",
  "|.##.##.#.###.#...................#.###.#.##.##.|",
  "|...............#################...............|",
  "|######.#######.....         .....#######.######|",
  " ...............#.## ###_### ##.#............... ",
  "|.#.#.#.#######...## #P I C# ##...#######.#.#.#.|",
  "|.#.#.#.#.....#.#.## ####### ##.#.#.....#.#.#.#.|",
  "|.........###.#.....         .....#.###.........|",
  "|######.#####.#.####.#.###.#.####.#.#####.######|",
  " ....................#.....#.................... ",
  "|.#####.###.###.#################.###.###.#####.|",
  "|.###.....#.#.......................#.#.....###.|",
  "|.###.#.#.#.#.#.#.#####. .#####.#.#.#.#.#.#.###.|",
  "|.....#.........#...............#.........#.....|",
  "\\-----------------------------------------------/"
}
{
}

void Board::print()
{
    std::cout << "\n\n\n";

    for (int row = 0; row < 16; row++)
    {
        std::cout << "    ";
        for (int col = 0; col < 49; col++)
        {
            if (row == 13 && col == 24)
            {
                SetColor(Yellow, Black);
                std::cout << 'O';
                continue;
            }
            if (row == 4 && col == 24)
            {
                SetColor(LightRed, Black);
                std::cout << 'B';
                continue;
            }

            switch (m_board[row][col])
            {
            //     - 
            case '#':
            case '-':
            case '|':
            case '/':
            case '_':
            case '\\': SetColor(DarkGray, Black);     break;
            //       -   
            case '.':  SetColor(White, Black);        break;
            case 'O':  SetColor(Yellow, Black);       break;
            //   - , ,   
            case 'B':  SetColor(LightRed, Black);     break;
            case 'P':  SetColor(LightMagenta, Black); break;
            case 'I':  SetColor(LightCyan, Black);    break;
            case 'C':  SetColor(LightGreen, Black);   break;
            //      - 
            default:   SetColor(LightGray, Black);    break;
            }
            std::cout << m_board[row][col];
        }
        std::cout << std::endl;
    }
    std::cout << "\n             :                 :       ";
}

void Board::update()
{
    m_board[0] = "/--------------\\   score:00000   /--------------\\";
    m_board[1] = "|.......#.....#\\-----------------/#.....#.......|";
    m_board[2] = "|.##.##.#.###.#...................#.###.#.##.##.|";
    m_board[3] = "|...............#################...............|";
    m_board[4] = "|######.#######.....         .....#######.######|";
    m_board[5] = " ...............#.## ###_### ##.#............... ";
    m_board[6] = "|.#.#.#.#######...## #P I C# ##...#######.#.#.#.|";
    m_board[7] = "|.#.#.#.#.....#.#.## ####### ##.#.#.....#.#.#.#.|";
    m_board[8] = "|.........###.#.....         .....#.###.........|";
    m_board[9] = "|######.#####.#.####.#.###.#.####.#.#####.######|";
    m_board[10] = " ....................#.....#.................... ";
    m_board[11] = "|.#####.###.###.#################.###.###.#####.|";
    m_board[12] = "|.###.....#.#.......................#.#.....###.|";
    m_board[13] = "|.###.#.#.#.#.#.#.#####. .#####.#.#.#.#.#.#.###.|";
    m_board[14] = "|.....#.........#...............#.........#.....|";
    m_board[15] = "\\-----------------------------------------------/";

    countDots = 354;
}

int Board::countDots = 354;