#include "Enemy.h"

int Enemy::countEnemies = 0;

Enemy::Enemy() : id(++countEnemies)
{
}

void Enemy::update()
{
    coordX = 24;
    coordY = 6;
    isActive = false;
}

void Enemy::move(PacMan& pacman)
{
    if (!isActive)
    {
        isActive = pacman.eatenDots() >= ((id - 1) * 40);

        if (isActive && id == 1)
        {
            coordX = 24;
            coordY = 4;
        }

        if (isActive && id > 1)
        {
            coordX = 24;
            coordY = 4;
            SetCoordCursor(22 + id * 2, 9);
            std::cout << ' ';
        }
    }
	if (isActive)
	{
        if (pacman.eatenDots() < ((id - 1) * 40)) { isActive = false; return; }

        enum movings { UP, LEFT, RIGHT, DOWN, TOTAL_MOVES };

        m_board = pacman.m_board;
        static int old_move = TOTAL_MOVES;

		switch (id)
		{
        case 1: SetColor(LightRed, Black);     name = 'B'; break;
        case 2: SetColor(LightMagenta, Black); name = 'P'; break;
		case 3: SetColor(LightCyan, Black);    name = 'I'; break;
		case 4: SetColor(LightGreen, Black);   name = 'C'; break;
		}

        //up, left, right, down
        std::array<bool, TOTAL_MOVES> moves{ 0 };

        char field;

        field = m_board.m_board[coordY - 1][coordX];
        if (field == ' ' || field == '.') moves[UP] = true;

        if (coordX != 0)
        {
            field = m_board.m_board[coordY][coordX - 1];
            if (field == ' ' || field == '.') moves[LEFT] = true;
        }
        if (coordX == 0) moves[LEFT] = true;

        if (coordX != 48)
        {
            field = m_board.m_board[coordY][coordX + 1];
            if (field == ' ' || field == '.') moves[RIGHT] = true;
        }
        if (coordX == 48) moves[RIGHT] = true;

        field = m_board.m_board[coordY + 1][coordX];
        if (field == ' ' || field == '.') moves[DOWN] = true;


        if (moves[UP] == true && moves[DOWN] == true && moves[LEFT] == false && moves[RIGHT] == false)
        {
            if (UP == old_move) moves[DOWN] = false;
            if (DOWN == old_move) moves[UP] = false;
        }

        else if (moves[UP] == false && moves[DOWN] == false && moves[LEFT] == true && moves[RIGHT] == true)
        {
            if (LEFT == old_move) moves[RIGHT] = false;
            if (RIGHT == old_move) moves[LEFT] = false;
        }

        else
        {
            if (old_move == LEFT) moves[RIGHT] = false;
            else if (old_move == RIGHT) moves[LEFT] = false;
            else if (old_move == UP) moves[DOWN] = false;
            else if (old_move == DOWN) moves[UP] = false;
        }

        while (true)
        {
			unsigned int moving = getRandomEnemyMoving();
			switch (moving)
			{
			// 
			case 1: 
			{
                if (!moves[UP]) continue;
				char field = m_board.m_board[coordY - 1][coordX];
				if (field == ' ' || field == '.')
				{
                    old_move = UP;
                    moveUp();
                    return;
				}
				break;
			}
			// 
			case 2:
			{
                if (!moves[LEFT]) continue;
                if (coordX == 0)
                {
                    old_move = LEFT;
                    moveLeft();
                    return;
                }
                char field = m_board.m_board[coordY][coordX - 1];
                if (field == ' ' || field == '.')
                {
                    old_move = LEFT;
                    moveLeft();
                    return;
                }
                break;
			}
			// 
			case 3:
			{
                if (!moves[RIGHT]) continue;
                if (coordX == 48)
                {
                    old_move = RIGHT;
                    moveRight();
                    return;
                }
                char field = m_board.m_board[coordY][coordX + 1];
                if (field == ' ' || field == '.')
                {
                    old_move = RIGHT;
                    moveRight();
                    return;
                }
                break;
			}
			// dybp
			case 4:
			{
                if (!moves[DOWN]) continue;
                char field = m_board.m_board[coordY + 1][coordX];
                if (field == ' ' || field == '.')
                {
                    old_move = DOWN;
                    moveDown();
                    return;
                }
                break;
			}
			}
		}
	}
}

//  
void Enemy::moveUp()
{
    coordY--;

    SetCoordCursor(coordX + 4, coordY + 3);
    std::cout << name;

    SetCoordCursor(coordX + 4, coordY + 4);
    SetColor(White, Black);
    std::cout << oldField;

    oldField = m_board.m_board[coordY][coordX];
}

//  
void Enemy::moveLeft()
{
    if (coordX != 0)
    {
        coordX--;

        SetCoordCursor(coordX + 4, coordY + 3);
        std::cout << name;

        SetCoordCursor(coordX + 5, coordY + 3);
        SetColor(White, Black);
        std::cout << oldField;

        oldField = m_board.m_board[coordY][coordX];
    }
    else
    {
        coordX = 48;

        SetCoordCursor(52, coordY + 3);
        std::cout << name;

        SetCoordCursor(4, coordY + 3);
        SetColor(White, Black);
        std::cout << oldField;

        oldField = m_board.m_board[coordY][coordX];
    }
}

//  
void Enemy::moveRight()
{
    if (coordX != 48)
    {
        coordX++;

        SetCoordCursor(coordX + 4, coordY + 3);
        std::cout << name;

        SetCoordCursor(coordX + 3, coordY + 3);
        SetColor(White, Black);
        std::cout << oldField;

        oldField = m_board.m_board[coordY][coordX];
    }
    else
    {
        coordX = 0;

        SetCoordCursor(4, coordY + 3);
        std::cout << name;

        SetCoordCursor(52, coordY + 3);
        SetColor(White, Black);
        std::cout << oldField;

        oldField = m_board.m_board[coordY][coordX];
    }
}

//  
void Enemy::moveDown()
{
    coordY++;

    SetCoordCursor(coordX + 4, coordY + 3);
    std::cout << name;

    SetCoordCursor(coordX + 4, coordY + 2);
    SetColor(White, Black);
    std::cout << oldField;

    oldField = m_board.m_board[coordY][coordX];
}

int Enemy::getRandomEnemyMoving()
{
	srand(static_cast<unsigned int>(time(NULL)) + rand());
	static const double fraction = 1.0 / (static_cast<double>(RAND_MAX) + 1.0);
	return static_cast<int>(rand() * fraction * 4 + 1);
}